Index: LMDZ6/trunk/libf/phylmd/lmdz_cloudth.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/lmdz_cloudth.F90	(revision 4673)
+++ LMDZ6/trunk/libf/phylmd/lmdz_cloudth.F90	(revision 4674)
@@ -602,20 +602,26 @@
       INCLUDE "FCTTRE.h"
 
-      INTEGER itap,ind1,ind2
-      INTEGER ngrid,klev,klon,l,ig 
+      integer, intent(in) :: ind2
+      integer, intent(in) :: ngrid,klev
+      
+      real, dimension(ngrid,klev), intent(in) :: ztv
+      real, dimension(ngrid), intent(in) :: po
+      real, dimension(ngrid,klev), intent(in) :: zqta
+      real, dimension(ngrid,klev+1), intent(in) :: fraca
+      real, dimension(ngrid), intent(out) :: qcloud
+      real, dimension(ngrid,klev), intent(out) :: ctot
+      real, dimension(ngrid,klev), intent(out) :: ctot_vol
+      real, dimension(ngrid,klev), intent(in) :: zpspsk
+      real, dimension(ngrid,klev+1), intent(in) :: paprs
+      real, dimension(ngrid,klev), intent(in) :: pplay
+      real, dimension(ngrid,klev), intent(in) :: ztla
+      real, dimension(ngrid,klev), intent(inout) :: zthl
+      real, dimension(ngrid,klev), intent(in) :: ratqs
+      real, dimension(ngrid), intent(in) :: zqs
+      real, dimension(ngrid,klev), intent(in) :: t
       real, dimension(ngrid,klev), intent(out) :: cloudth_sth,cloudth_senv,cloudth_sigmath,cloudth_sigmaenv
-      
-      REAL ztv(ngrid,klev)
-      REAL po(ngrid)
+
+
       REAL zqenv(ngrid)   
-      REAL zqta(ngrid,klev)
-          
-      REAL fraca(ngrid,klev+1)
-      REAL zpspsk(ngrid,klev)
-      REAL paprs(ngrid,klev+1)
-      REAL pplay(ngrid,klev)
-      REAL ztla(ngrid,klev)
-      REAL zthl(ngrid,klev)
-
       REAL zqsatth(ngrid,klev)
       REAL zqsatenv(ngrid,klev)
@@ -628,10 +634,7 @@
       REAL cth(ngrid,klev)
       REAL cenv(ngrid,klev)   
-      REAL ctot(ngrid,klev)
       REAL cth_vol(ngrid,klev)
       REAL cenv_vol(ngrid,klev)
-      REAL ctot_vol(ngrid,klev)
       REAL rneb(ngrid,klev)      
-      REAL t(ngrid,klev)
       REAL qsatmmussig1,qsatmmussig2,sqrt2pi,sqrt2,sqrtpi,pi
       REAL rdd,cppd,Lv
@@ -641,10 +644,10 @@
       REAL Tbef,zdelta,qsatbef,zcor
       REAL qlbef  
-      REAL ratqs(ngrid,klev) ! Determine the width of the vapour distribution
       REAL zpdf_sig(ngrid),zpdf_k(ngrid),zpdf_delta(ngrid)
       REAL zpdf_a(ngrid),zpdf_b(ngrid),zpdf_e1(ngrid),zpdf_e2(ngrid) 
-      REAL zqs(ngrid), qcloud(ngrid)
       REAL erf
 
+
+      INTEGER :: ind1,l, ig
 
       IF (iflag_cloudth_vert.GE.1) THEN
Index: LMDZ6/trunk/libf/phylmd/lmdz_lscp.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/lmdz_lscp.F90	(revision 4673)
+++ LMDZ6/trunk/libf/phylmd/lmdz_lscp.F90	(revision 4674)
@@ -144,5 +144,5 @@
   REAL, DIMENSION(klon,klev),      INTENT(INOUT)   :: zthl         ! liquid potential temperature [K]
   REAL, DIMENSION(klon,klev),      INTENT(INOUT):: ratqs            ! function of pressure that sets the large-scale
-  REAL, DIMENSION(klon,klev),      INTENT(INOUT):: beta             ! conversion rate of condensed water
+  REAL, DIMENSION(klon,klev),      INTENT(OUT):: beta             ! conversion rate of condensed water
 
 
Index: LMDZ6/trunk/libf/phylmd/lmdz_lscp_old.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/lmdz_lscp_old.F90	(revision 4673)
+++ LMDZ6/trunk/libf/phylmd/lmdz_lscp_old.F90	(revision 4674)
@@ -76,5 +76,5 @@
   REAL, DIMENSION(klon,klev),      INTENT(IN)   :: zqta, fraca 
   REAL, DIMENSION(klon,klev),      INTENT(IN)   :: zpspsk, ztla
-  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: zthl
+  REAL, DIMENSION(klon,klev),      INTENT(INOUT)   :: zthl
   !
   !  Input/output
@@ -173,4 +173,12 @@
   !---------------------------------------------------------------
   !
+  ! Fonctions en ligne:
+  !
+  REAL ::  fallvs,fallvc, zzz ! Vitesse de chute pour cristaux de glace
+                     ! (Heymsfield & Donner, 1990)
+  fallvc (zzz) = 3.29/2.0 * ((zzz)**0.16) * ffallv_con
+  fallvs (zzz) = 3.29/2.0 * ((zzz)**0.16) * ffallv_lsc
+  !
+  !---------------------------------------------------------------
   !AA Variables traceurs:
   !AA  Provisoire !!! Parametres alpha du lessivage
@@ -189,12 +197,5 @@
   REAL, DIMENSION(klon) :: zlh_solid
   REAL :: zm_solid
-  !---------------------------------------------------------------
-  !
-  ! Fonctions en ligne:
-  !
-  REAL ::  fallvs,fallvc,zzz ! Vitesse de chute pour cristaux de glace
-                     ! (Heymsfield & Donner, 1990)
-  fallvc (zzz) = 3.29/2.0 * ((zzz)**0.16) * ffallv_con
-  fallvs (zzz) = 3.29/2.0 * ((zzz)**0.16) * ffallv_lsc
+
 
   !